priborkaZiLStateEvent = {};
priborkaZiLStateEvent_mt = Class(priborkaZiLStateEvent, Event);

InitEventClass(priborkaZiLStateEvent, "priborkaZiLStateEvent");

function priborkaZiLStateEvent:emptyNew()
    local self = Event:new(priborkaZiLStateEvent_mt);
    self.className="priborkaZiLStateEvent";
    return self;
end;

function priborkaZiLStateEvent:new(vehicle, state)
    local self = priborkaZiLStateEvent:emptyNew()
    self.vehicle = vehicle;
	self.priborkaZiLState = state;
    return self;
end;

function priborkaZiLStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.priborkaZiLState = streamReadInt8(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function priborkaZiLStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt8(streamId, self.priborkaZiLState);
end;

function priborkaZiLStateEvent:run(connection)
	self.vehicle:setPriborkaZiLStateEvent(self.priborkaZiLState, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(PriborkaZiLStateEvent:new(self.vehicle, self.priborkaZiLState), nil, connection, self.object);
    end;
end;


function priborkaZiLStateEvent.sendEvent(vehicle, state, noEventSend)
	if vehicle.currentPriborkaZiL ~= state then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(PriborkaZiLStateEvent:new(vehicle, state), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(PriborkaZiLStateEvent:new(vehicle, state));
			end;
		end;
	end;
end;